Merge branch 'bc/fix-array-syntax-for-3.0-in-completion-bash'
[git.git] / t / test-lib-functions.sh
1 #!/bin/sh
2 #
3 # Copyright (c) 2005 Junio C Hamano
4 #
5 # This program is free software: you can redistribute it and/or modify
6 # it under the terms of the GNU General Public License as published by
7 # the Free Software Foundation, either version 2 of the License, or
8 # (at your option) any later version.
9 #
10 # This program is distributed in the hope that it will be useful,
11 # but WITHOUT ANY WARRANTY; without even the implied warranty of
12 # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
13 # GNU General Public License for more details.
14 #
15 # You should have received a copy of the GNU General Public License
16 # along with this program.  If not, see http://www.gnu.org/licenses/ .
17
18 # The semantics of the editor variables are that of invoking
19 # sh -c "$EDITOR \"$@\"" files ...
20 #
21 # If our trash directory contains shell metacharacters, they will be
22 # interpreted if we just set $EDITOR directly, so do a little dance with
23 # environment variables to work around this.
24 #
25 # In particular, quoting isn't enough, as the path may contain the same quote
26 # that we're using.
27 test_set_editor () {
28         FAKE_EDITOR="$1"
29         export FAKE_EDITOR
30         EDITOR='"$FAKE_EDITOR"'
31         export EDITOR
32 }
33
34 test_decode_color () {
35         awk '
36                 function name(n) {
37                         if (n == 0) return "RESET";
38                         if (n == 1) return "BOLD";
39                         if (n == 30) return "BLACK";
40                         if (n == 31) return "RED";
41                         if (n == 32) return "GREEN";
42                         if (n == 33) return "YELLOW";
43                         if (n == 34) return "BLUE";
44                         if (n == 35) return "MAGENTA";
45                         if (n == 36) return "CYAN";
46                         if (n == 37) return "WHITE";
47                         if (n == 40) return "BLACK";
48                         if (n == 41) return "BRED";
49                         if (n == 42) return "BGREEN";
50                         if (n == 43) return "BYELLOW";
51                         if (n == 44) return "BBLUE";
52                         if (n == 45) return "BMAGENTA";
53                         if (n == 46) return "BCYAN";
54                         if (n == 47) return "BWHITE";
55                 }
56                 {
57                         while (match($0, /\033\[[0-9;]*m/) != 0) {
58                                 printf "%s<", substr($0, 1, RSTART-1);
59                                 codes = substr($0, RSTART+2, RLENGTH-3);
60                                 if (length(codes) == 0)
61                                         printf "%s", name(0)
62                                 else {
63                                         n = split(codes, ary, ";");
64                                         sep = "";
65                                         for (i = 1; i <= n; i++) {
66                                                 printf "%s%s", sep, name(ary[i]);
67                                                 sep = ";"
68                                         }
69                                 }
70                                 printf ">";
71                                 $0 = substr($0, RSTART + RLENGTH, length($0) - RSTART - RLENGTH + 1);
72                         }
73                         print
74                 }
75         '
76 }
77
78 nul_to_q () {
79         "$PERL_PATH" -pe 'y/\000/Q/'
80 }
81
82 q_to_nul () {
83         "$PERL_PATH" -pe 'y/Q/\000/'
84 }
85
86 q_to_cr () {
87         tr Q '\015'
88 }
89
90 q_to_tab () {
91         tr Q '\011'
92 }
93
94 append_cr () {
95         sed -e 's/$/Q/' | tr Q '\015'
96 }
97
98 remove_cr () {
99         tr '\015' Q | sed -e 's/Q$//'
100 }
101
102 # In some bourne shell implementations, the "unset" builtin returns
103 # nonzero status when a variable to be unset was not set in the first
104 # place.
105 #
106 # Use sane_unset when that should not be considered an error.
107
108 sane_unset () {
109         unset "$@"
110         return 0
111 }
112
113 test_tick () {
114         if test -z "${test_tick+set}"
115         then
116                 test_tick=1112911993
117         else
118                 test_tick=$(($test_tick + 60))
119         fi
120         GIT_COMMITTER_DATE="$test_tick -0700"
121         GIT_AUTHOR_DATE="$test_tick -0700"
122         export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
123 }
124
125 # Stop execution and start a shell. This is useful for debugging tests and
126 # only makes sense together with "-v".
127 #
128 # Be sure to remove all invocations of this command before submitting.
129
130 test_pause () {
131         if test "$verbose" = t; then
132                 "$SHELL_PATH" <&6 >&3 2>&4
133         else
134                 error >&5 "test_pause requires --verbose"
135         fi
136 }
137
138 # Call test_commit with the arguments "<message> [<file> [<contents>]]"
139 #
140 # This will commit a file with the given contents and the given commit
141 # message.  It will also add a tag with <message> as name.
142 #
143 # Both <file> and <contents> default to <message>.
144
145 test_commit () {
146         notick= &&
147         signoff= &&
148         while test $# != 0
149         do
150                 case "$1" in
151                 --notick)
152                         notick=yes
153                         ;;
154                 --signoff)
155                         signoff="$1"
156                         ;;
157                 *)
158                         break
159                         ;;
160                 esac
161                 shift
162         done &&
163         file=${2:-"$1.t"} &&
164         echo "${3-$1}" > "$file" &&
165         git add "$file" &&
166         if test -z "$notick"
167         then
168                 test_tick
169         fi &&
170         git commit $signoff -m "$1" &&
171         git tag "$1"
172 }
173
174 # Call test_merge with the arguments "<message> <commit>", where <commit>
175 # can be a tag pointing to the commit-to-merge.
176
177 test_merge () {
178         test_tick &&
179         git merge -m "$1" "$2" &&
180         git tag "$1"
181 }
182
183 # This function helps systems where core.filemode=false is set.
184 # Use it instead of plain 'chmod +x' to set or unset the executable bit
185 # of a file in the working directory and add it to the index.
186
187 test_chmod () {
188         chmod "$@" &&
189         git update-index --add "--chmod=$@"
190 }
191
192 # Unset a configuration variable, but don't fail if it doesn't exist.
193 test_unconfig () {
194         git config --unset-all "$@"
195         config_status=$?
196         case "$config_status" in
197         5) # ok, nothing to unset
198                 config_status=0
199                 ;;
200         esac
201         return $config_status
202 }
203
204 # Set git config, automatically unsetting it after the test is over.
205 test_config () {
206         test_when_finished "test_unconfig '$1'" &&
207         git config "$@"
208 }
209
210 test_config_global () {
211         test_when_finished "test_unconfig --global '$1'" &&
212         git config --global "$@"
213 }
214
215 write_script () {
216         {
217                 echo "#!${2-"$SHELL_PATH"}" &&
218                 cat
219         } >"$1" &&
220         chmod +x "$1"
221 }
222
223 # Use test_set_prereq to tell that a particular prerequisite is available.
224 # The prerequisite can later be checked for in two ways:
225 #
226 # - Explicitly using test_have_prereq.
227 #
228 # - Implicitly by specifying the prerequisite tag in the calls to
229 #   test_expect_{success,failure,code}.
230 #
231 # The single parameter is the prerequisite tag (a simple word, in all
232 # capital letters by convention).
233
234 test_set_prereq () {
235         satisfied_prereq="$satisfied_prereq$1 "
236 }
237 satisfied_prereq=" "
238 lazily_testable_prereq= lazily_tested_prereq=
239
240 # Usage: test_lazy_prereq PREREQ 'script'
241 test_lazy_prereq () {
242         lazily_testable_prereq="$lazily_testable_prereq$1 "
243         eval test_prereq_lazily_$1=\$2
244 }
245
246 test_run_lazy_prereq_ () {
247         script='
248 mkdir -p "$TRASH_DIRECTORY/prereq-test-dir" &&
249 (
250         cd "$TRASH_DIRECTORY/prereq-test-dir" &&'"$2"'
251 )'
252         say >&3 "checking prerequisite: $1"
253         say >&3 "$script"
254         test_eval_ "$script"
255         eval_ret=$?
256         rm -rf "$TRASH_DIRECTORY/prereq-test-dir"
257         if test "$eval_ret" = 0; then
258                 say >&3 "prerequisite $1 ok"
259         else
260                 say >&3 "prerequisite $1 not satisfied"
261         fi
262         return $eval_ret
263 }
264
265 test_have_prereq () {
266         # prerequisites can be concatenated with ','
267         save_IFS=$IFS
268         IFS=,
269         set -- $*
270         IFS=$save_IFS
271
272         total_prereq=0
273         ok_prereq=0
274         missing_prereq=
275
276         for prerequisite
277         do
278                 case "$prerequisite" in
279                 !*)
280                         negative_prereq=t
281                         prerequisite=${prerequisite#!}
282                         ;;
283                 *)
284                         negative_prereq=
285                 esac
286
287                 case " $lazily_tested_prereq " in
288                 *" $prerequisite "*)
289                         ;;
290                 *)
291                         case " $lazily_testable_prereq " in
292                         *" $prerequisite "*)
293                                 eval "script=\$test_prereq_lazily_$prerequisite" &&
294                                 if test_run_lazy_prereq_ "$prerequisite" "$script"
295                                 then
296                                         test_set_prereq $prerequisite
297                                 fi
298                                 lazily_tested_prereq="$lazily_tested_prereq$prerequisite "
299                         esac
300                         ;;
301                 esac
302
303                 total_prereq=$(($total_prereq + 1))
304                 case "$satisfied_prereq" in
305                 *" $prerequisite "*)
306                         satisfied_this_prereq=t
307                         ;;
308                 *)
309                         satisfied_this_prereq=
310                 esac
311
312                 case "$satisfied_this_prereq,$negative_prereq" in
313                 t,|,t)
314                         ok_prereq=$(($ok_prereq + 1))
315                         ;;
316                 *)
317                         # Keep a list of missing prerequisites; restore
318                         # the negative marker if necessary.
319                         prerequisite=${negative_prereq:+!}$prerequisite
320                         if test -z "$missing_prereq"
321                         then
322                                 missing_prereq=$prerequisite
323                         else
324                                 missing_prereq="$prerequisite,$missing_prereq"
325                         fi
326                 esac
327         done
328
329         test $total_prereq = $ok_prereq
330 }
331
332 test_declared_prereq () {
333         case ",$test_prereq," in
334         *,$1,*)
335                 return 0
336                 ;;
337         esac
338         return 1
339 }
340
341 test_expect_failure () {
342         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
343         test "$#" = 2 ||
344         error "bug in the test script: not 2 or 3 parameters to test-expect-failure"
345         export test_prereq
346         if ! test_skip "$@"
347         then
348                 say >&3 "checking known breakage: $2"
349                 if test_run_ "$2" expecting_failure
350                 then
351                         test_known_broken_ok_ "$1"
352                 else
353                         test_known_broken_failure_ "$1"
354                 fi
355         fi
356         echo >&3 ""
357 }
358
359 test_expect_success () {
360         test "$#" = 3 && { test_prereq=$1; shift; } || test_prereq=
361         test "$#" = 2 ||
362         error "bug in the test script: not 2 or 3 parameters to test-expect-success"
363         export test_prereq
364         if ! test_skip "$@"
365         then
366                 say >&3 "expecting success: $2"
367                 if test_run_ "$2"
368                 then
369                         test_ok_ "$1"
370                 else
371                         test_failure_ "$@"
372                 fi
373         fi
374         echo >&3 ""
375 }
376
377 # test_external runs external test scripts that provide continuous
378 # test output about their progress, and succeeds/fails on
379 # zero/non-zero exit code.  It outputs the test output on stdout even
380 # in non-verbose mode, and announces the external script with "# run
381 # <n>: ..." before running it.  When providing relative paths, keep in
382 # mind that all scripts run in "trash directory".
383 # Usage: test_external description command arguments...
384 # Example: test_external 'Perl API' perl ../path/to/test.pl
385 test_external () {
386         test "$#" = 4 && { test_prereq=$1; shift; } || test_prereq=
387         test "$#" = 3 ||
388         error >&5 "bug in the test script: not 3 or 4 parameters to test_external"
389         descr="$1"
390         shift
391         export test_prereq
392         if ! test_skip "$descr" "$@"
393         then
394                 # Announce the script to reduce confusion about the
395                 # test output that follows.
396                 say_color "" "# run $test_count: $descr ($*)"
397                 # Export TEST_DIRECTORY, TRASH_DIRECTORY and GIT_TEST_LONG
398                 # to be able to use them in script
399                 export TEST_DIRECTORY TRASH_DIRECTORY GIT_TEST_LONG
400                 # Run command; redirect its stderr to &4 as in
401                 # test_run_, but keep its stdout on our stdout even in
402                 # non-verbose mode.
403                 "$@" 2>&4
404                 if [ "$?" = 0 ]
405                 then
406                         if test $test_external_has_tap -eq 0; then
407                                 test_ok_ "$descr"
408                         else
409                                 say_color "" "# test_external test $descr was ok"
410                                 test_success=$(($test_success + 1))
411                         fi
412                 else
413                         if test $test_external_has_tap -eq 0; then
414                                 test_failure_ "$descr" "$@"
415                         else
416                                 say_color error "# test_external test $descr failed: $@"
417                                 test_failure=$(($test_failure + 1))
418                         fi
419                 fi
420         fi
421 }
422
423 # Like test_external, but in addition tests that the command generated
424 # no output on stderr.
425 test_external_without_stderr () {
426         # The temporary file has no (and must have no) security
427         # implications.
428         tmp=${TMPDIR:-/tmp}
429         stderr="$tmp/git-external-stderr.$$.tmp"
430         test_external "$@" 4> "$stderr"
431         [ -f "$stderr" ] || error "Internal error: $stderr disappeared."
432         descr="no stderr: $1"
433         shift
434         say >&3 "# expecting no stderr from previous command"
435         if [ ! -s "$stderr" ]; then
436                 rm "$stderr"
437
438                 if test $test_external_has_tap -eq 0; then
439                         test_ok_ "$descr"
440                 else
441                         say_color "" "# test_external_without_stderr test $descr was ok"
442                         test_success=$(($test_success + 1))
443                 fi
444         else
445                 if [ "$verbose" = t ]; then
446                         output=`echo; echo "# Stderr is:"; cat "$stderr"`
447                 else
448                         output=
449                 fi
450                 # rm first in case test_failure exits.
451                 rm "$stderr"
452                 if test $test_external_has_tap -eq 0; then
453                         test_failure_ "$descr" "$@" "$output"
454                 else
455                         say_color error "# test_external_without_stderr test $descr failed: $@: $output"
456                         test_failure=$(($test_failure + 1))
457                 fi
458         fi
459 }
460
461 # debugging-friendly alternatives to "test [-f|-d|-e]"
462 # The commands test the existence or non-existence of $1. $2 can be
463 # given to provide a more precise diagnosis.
464 test_path_is_file () {
465         if ! [ -f "$1" ]
466         then
467                 echo "File $1 doesn't exist. $*"
468                 false
469         fi
470 }
471
472 test_path_is_dir () {
473         if ! [ -d "$1" ]
474         then
475                 echo "Directory $1 doesn't exist. $*"
476                 false
477         fi
478 }
479
480 test_path_is_missing () {
481         if [ -e "$1" ]
482         then
483                 echo "Path exists:"
484                 ls -ld "$1"
485                 if [ $# -ge 1 ]; then
486                         echo "$*"
487                 fi
488                 false
489         fi
490 }
491
492 # test_line_count checks that a file has the number of lines it
493 # ought to. For example:
494 #
495 #       test_expect_success 'produce exactly one line of output' '
496 #               do something >output &&
497 #               test_line_count = 1 output
498 #       '
499 #
500 # is like "test $(wc -l <output) = 1" except that it passes the
501 # output through when the number of lines is wrong.
502
503 test_line_count () {
504         if test $# != 3
505         then
506                 error "bug in the test script: not 3 parameters to test_line_count"
507         elif ! test $(wc -l <"$3") "$1" "$2"
508         then
509                 echo "test_line_count: line count for $3 !$1 $2"
510                 cat "$3"
511                 return 1
512         fi
513 }
514
515 # This is not among top-level (test_expect_success | test_expect_failure)
516 # but is a prefix that can be used in the test script, like:
517 #
518 #       test_expect_success 'complain and die' '
519 #           do something &&
520 #           do something else &&
521 #           test_must_fail git checkout ../outerspace
522 #       '
523 #
524 # Writing this as "! git checkout ../outerspace" is wrong, because
525 # the failure could be due to a segv.  We want a controlled failure.
526
527 test_must_fail () {
528         "$@"
529         exit_code=$?
530         if test $exit_code = 0; then
531                 echo >&2 "test_must_fail: command succeeded: $*"
532                 return 1
533         elif test $exit_code -gt 129 -a $exit_code -le 192; then
534                 echo >&2 "test_must_fail: died by signal: $*"
535                 return 1
536         elif test $exit_code = 127; then
537                 echo >&2 "test_must_fail: command not found: $*"
538                 return 1
539         fi
540         return 0
541 }
542
543 # Similar to test_must_fail, but tolerates success, too.  This is
544 # meant to be used in contexts like:
545 #
546 #       test_expect_success 'some command works without configuration' '
547 #               test_might_fail git config --unset all.configuration &&
548 #               do something
549 #       '
550 #
551 # Writing "git config --unset all.configuration || :" would be wrong,
552 # because we want to notice if it fails due to segv.
553
554 test_might_fail () {
555         "$@"
556         exit_code=$?
557         if test $exit_code -gt 129 -a $exit_code -le 192; then
558                 echo >&2 "test_might_fail: died by signal: $*"
559                 return 1
560         elif test $exit_code = 127; then
561                 echo >&2 "test_might_fail: command not found: $*"
562                 return 1
563         fi
564         return 0
565 }
566
567 # Similar to test_must_fail and test_might_fail, but check that a
568 # given command exited with a given exit code. Meant to be used as:
569 #
570 #       test_expect_success 'Merge with d/f conflicts' '
571 #               test_expect_code 1 git merge "merge msg" B master
572 #       '
573
574 test_expect_code () {
575         want_code=$1
576         shift
577         "$@"
578         exit_code=$?
579         if test $exit_code = $want_code
580         then
581                 return 0
582         fi
583
584         echo >&2 "test_expect_code: command exited with $exit_code, we wanted $want_code $*"
585         return 1
586 }
587
588 # test_cmp is a helper function to compare actual and expected output.
589 # You can use it like:
590 #
591 #       test_expect_success 'foo works' '
592 #               echo expected >expected &&
593 #               foo >actual &&
594 #               test_cmp expected actual
595 #       '
596 #
597 # This could be written as either "cmp" or "diff -u", but:
598 # - cmp's output is not nearly as easy to read as diff -u
599 # - not all diff versions understand "-u"
600
601 test_cmp() {
602         $GIT_TEST_CMP "$@"
603 }
604
605 # Tests that its two parameters refer to the same revision
606 test_cmp_rev () {
607         git rev-parse --verify "$1" >expect.rev &&
608         git rev-parse --verify "$2" >actual.rev &&
609         test_cmp expect.rev actual.rev
610 }
611
612 # Print a sequence of numbers or letters in increasing order.  This is
613 # similar to GNU seq(1), but the latter might not be available
614 # everywhere (and does not do letters).  It may be used like:
615 #
616 #       for i in `test_seq 100`; do
617 #               for j in `test_seq 10 20`; do
618 #                       for k in `test_seq a z`; do
619 #                               echo $i-$j-$k
620 #                       done
621 #               done
622 #       done
623
624 test_seq () {
625         case $# in
626         1)      set 1 "$@" ;;
627         2)      ;;
628         *)      error "bug in the test script: not 1 or 2 parameters to test_seq" ;;
629         esac
630         "$PERL_PATH" -le 'print for $ARGV[0]..$ARGV[1]' -- "$@"
631 }
632
633 # This function can be used to schedule some commands to be run
634 # unconditionally at the end of the test to restore sanity:
635 #
636 #       test_expect_success 'test core.capslock' '
637 #               git config core.capslock true &&
638 #               test_when_finished "git config --unset core.capslock" &&
639 #               hello world
640 #       '
641 #
642 # That would be roughly equivalent to
643 #
644 #       test_expect_success 'test core.capslock' '
645 #               git config core.capslock true &&
646 #               hello world
647 #               git config --unset core.capslock
648 #       '
649 #
650 # except that the greeting and config --unset must both succeed for
651 # the test to pass.
652 #
653 # Note that under --immediate mode, no clean-up is done to help diagnose
654 # what went wrong.
655
656 test_when_finished () {
657         test_cleanup="{ $*
658                 } && (exit \"\$eval_ret\"); eval_ret=\$?; $test_cleanup"
659 }
660
661 # Most tests can use the created repository, but some may need to create more.
662 # Usage: test_create_repo <directory>
663 test_create_repo () {
664         test "$#" = 1 ||
665         error "bug in the test script: not 1 parameter to test-create-repo"
666         repo="$1"
667         mkdir -p "$repo"
668         (
669                 cd "$repo" || error "Cannot setup test environment"
670                 "$GIT_EXEC_PATH/git-init" "--template=$GIT_BUILD_DIR/templates/blt/" >&3 2>&4 ||
671                 error "cannot run git init -- have you built things yet?"
672                 mv .git/hooks .git/hooks-disabled
673         ) || exit
674 }